var ifc = require('../module.js');
var fs = require('fs');

//testCreateAndDump();
testParse();

function testCreateAndDump() {
    var project = ifc.addProject('Test Project');
    var site = project.addSite('Test Site');
    var building = site.addBuilding(project, 'Test Building 1');

    building = site.addBuilding(project, 'Test Building 2');

    var floor = building.addFloor(project, 'Test Floor');
    var space = floor.addSpace(project, 'Test Space');

    space.setRectangleRepresentation(4000, 4000, 5000, 8000);

    var door = floor.addDoor(project, 'Door 1');

    door.setPointRepresentation(3000, 3000);

    project.getRelContainedInSpatialStructure(space).addRelatedElement(door);

    // Subsequent adds should be idempotent

    project.getRelContainedInSpatialStructure(space).addRelatedElement(door);
    project.getRelContainedInSpatialStructure(space).addRelatedElement(door);
    project.getRelContainedInSpatialStructure(space).addRelatedElement(door);
    project.getRelContainedInSpatialStructure(space).addRelatedElement(door);

    fs.writeFileSync('./output/ifc.json', project.stringify());
    fs.writeFileSync('./output/data.js', 'var data = ' + project.stringify() + ';');

    console.log('Written file');

    project = ifc.bind(JSON.parse(fs.readFileSync('./output/ifc.json')));

    project.list();

    var file = fs.createWriteStream('./output/test.ifc');

    project.dump(file);

    file.end();

    site = project.getSite(site.id);
    building = site.getBuilding(building.id);
    floor = building.getFloor(floor.id);

    console.log('Matching Spaces: ' + floor.getSpaceWithWallsCloseToPoint(1450, 30).length);
    console.log('Matching Spaces: ' + floor.getSpaceWithWallsCloseToPoint(1700, 200).length);
}

function testParse() {
    ifc.parse(fs.createReadStream('./test/examples/kubus2.ifc'), function (errors, project) {
        if (errors.length > 0) {
            for (var n in errors) {
                console.log(errors[n].type + ' ' + errors[n].type.name + ': ' + errors[n].message);
            }
        } else {
            fs.writeFileSync('./test/output/ifc.json', project.stringify());
            fs.writeFileSync('./test/output/data.js', 'var data = ' + project.stringify() + ';');

            console.log('Written file');

            var project = ifc.bind(JSON.parse(fs.readFileSync('./test/output/ifc.json')));

            ifc.bind(project);

            project.list();
        }
    });
}
